/*
 *		quicktime.app Library
 *
 *		 1996, Copyright, Apple Computer
 *		All rights reserved
 *
 *		$Workfile:: ControlPanel.java                                                  $
 *		$Archive:: /Biscotti/QTJavaDemos/QTEffects/src/qteffect/ControlPanel.java        $
 *
 *		Authors: Bill Stewart
 */
package qteffect;

import java.awt.*;
import java.awt.event.*;

import quicktime.*;
import quicktime.std.image.*;
import quicktime.app.image.QTFilter;
import quicktime.app.display.*;
import PlayQTEffectApp;
/**
 * A simple panel of AWT objects to demonstrate how AWT can be used to control a
 * QuickTime movie.
 */
public class FilterPanel extends Panel implements Errors {

//_________________________ CLASS METHODS
	public FilterPanel (QTFilter ef, QTCanvas c) throws QTException {
		this.filter = ef;
		final QTCanvas cv = c;
		
		GridBagLayout gb = new GridBagLayout();
		setLayout (gb);
		setFont (new Font("Helvetica", Font.BOLD, 10));

		GridBagConstraints cons = new GridBagConstraints();
		cons.fill = GridBagConstraints.HORIZONTAL;

		cons.gridheight = 1;		
		cons.insets = new Insets (2, 2, 2, 2);
		
		cons.gridwidth = 3;
		cons.gridy = 0;
		cons.gridx = 0;
		add (padLabel, cons);
		
		++cons.gridy;
		add (chooseEffectButton, cons);
		
		chooseEffectButton.addActionListener (new ActionListener () {
				public void actionPerformed (ActionEvent event) {
					if (PlayQTEffectApp.useEnhancedParameterDialog) {
						try {
							PlayQTEffectApp.showEffectDialog (filter);
						} catch (QTException e) {
							if (e.errorCode() != userCanceledErr)
								e.printStackTrace();
						} catch (java.io.IOException ioe) {
							ioe.printStackTrace();
						}
					} else {
						try {
							PlayQTEffectApp.showDialog (filter);
						} catch (QTException e) {
							if (e.errorCode() != userCanceledErr)
								e.printStackTrace();
						}
					}
				}
			});
			
	}

//_________________________ INSTANCE VARIABLES
	private Button chooseEffectButton = new Button("Choose Effect");
	private Label 	padLabel = new Label ("", Label.RIGHT);
	
	private QTFilter filter;
	
//_________________________ INSTANCE METHODS
	/**
	 * @return a Dimension object which defines the minimum size
	 */	 
	public Dimension getMinimumSize() { return new Dimension (0, 100); }

	/**
	 * @return a Dimension object which defines the preferred size
	 */	 
	public Dimension getPreferredSize() { return getMinimumSize(); }
}
